From 17e997de75c65715965b71a27fdbe7af7e9d70cc Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 11 2016 18:22:23 +0000
Subject: [PATCH 624/1001] Add tests for React front end


* Use jest test suite (recommended by React team)

---

diff --git a/hubs/static/client/.babelrc b/hubs/static/client/.babelrc
index 9926dbe..aef231b 100644
--- a/hubs/static/client/.babelrc
+++ b/hubs/static/client/.babelrc
@@ -1,5 +1,5 @@
 {
-  "presets" : ["es2015", "react"],
+  "presets" : ["es2015", "react", "stage-1"],
   "plugins": ["transform-class-properties"]
 }
 
diff --git a/hubs/static/client/app/__tests__/Feed.test.js b/hubs/static/client/app/__tests__/Feed.test.js
new file mode 100644
index 0000000..ae93f29
--- /dev/null
+++ b/hubs/static/client/app/__tests__/Feed.test.js
@@ -0,0 +1,34 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../components/Feed.jsx');
+
+import React from 'react';
+import TestUtils from 'react-addons-test-utils';
+
+import Feed from '../components/Feed.jsx';
+
+describe('Feed', () => {
+  const matches = [{
+    markup: '<a href="https://pagure.io/fedora-hubs">Link</a>',
+    date_time: new Date(),
+    link: 'https://pagure.io/fedora-hubs',
+    secondary_icon: 'https://placekitten.com/g/200/300',
+  }];
+
+  const options = {
+    messageLimit: 100
+  };
+
+  it('should set the correct state', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Feed matches={matches} options={options} />
+    );
+
+    const state = {
+      matches,
+      messageLimit: 100,
+      sse: true,
+    };
+    expect(component.state).toEqual(state);
+  });
+});
diff --git a/hubs/static/client/app/__tests__/Icon.test.js b/hubs/static/client/app/__tests__/Icon.test.js
new file mode 100644
index 0000000..920c853
--- /dev/null
+++ b/hubs/static/client/app/__tests__/Icon.test.js
@@ -0,0 +1,36 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../components/Icon.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Icon from '../components/Icon.jsx';
+
+describe('Icon', () => {
+  const match = {
+    link: 'https://pagure.io/fedora-hubs',
+    secondary_icon: 'https://placekitten.com/g/200/300',
+  };
+
+  it('has the correct link', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Icon match={match} />
+    );
+    expect(component).toBeTruthy();
+    const node = ReactDOM.findDOMNode(component);
+    const link = node.querySelector('a');
+    expect(link.getAttribute('href')).toEqual(match.link);
+  });
+  it('has the correct image source', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Icon match={match} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const image = node.querySelector('img');
+    expect(image.getAttribute('src')).toEqual(match.secondary_icon);
+  });
+});
diff --git a/hubs/static/client/app/__tests__/Markup.test.js b/hubs/static/client/app/__tests__/Markup.test.js
new file mode 100644
index 0000000..d2aea84
--- /dev/null
+++ b/hubs/static/client/app/__tests__/Markup.test.js
@@ -0,0 +1,30 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../components/Markup.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Markup from '../components/Markup.jsx';
+
+describe('Markup', () => {
+  const match = {
+    markup: '<a href="https://pagure.io/fedora-hubs">Link</a>',
+    date_time: new Date(),
+  };
+
+  it('should set the inner html of the markup', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Markup match={match} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const header = node.querySelector('h4');
+
+    expect(header.innerHTML).toEqual(match.markup);
+  });
+
+  // we don't test TimeAgo, the library should have its own tests
+});
diff --git a/hubs/static/client/app/__tests__/Panel.test.js b/hubs/static/client/app/__tests__/Panel.test.js
new file mode 100644
index 0000000..c8632c5
--- /dev/null
+++ b/hubs/static/client/app/__tests__/Panel.test.js
@@ -0,0 +1,30 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../components/Panel.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Panel from '../components/Panel.jsx';
+
+describe('Panel', () => {
+  const match = {
+    markup: '<a href="https://pagure.io/fedora-hubs">Link</a>',
+    date_time: new Date(),
+    link: 'https://pagure.io/fedora-hubs',
+    secondary_icon: 'https://placekitten.com/g/200/300',
+  };
+
+  it('should render the card block', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Panel match={match} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const block = node.querySelector('.card-block');
+
+    expect(block).toBeTruthy();
+  });
+});
diff --git a/hubs/static/client/app/components/Feed.jsx b/hubs/static/client/app/components/Feed.jsx
index eae102a..b196bdb 100644
--- a/hubs/static/client/app/components/Feed.jsx
+++ b/hubs/static/client/app/components/Feed.jsx
@@ -15,7 +15,10 @@ export default class Feed extends React.Component {
     if (!this.props.url || !this.state.sse) {
       return;
     }
-    this.source = (!!window.EventSource) ? new EventSource(this.props.url) : {};
+    this.source = (!!window.EventSource) ? new EventSource(this.props.url) : null;
+    if (!this.source) {
+      return;
+    }
     this.source.addEventListener('error', () => {
       this.state.sse = false;
     }, false);
diff --git a/hubs/static/client/app/components/Icon.jsx b/hubs/static/client/app/components/Icon.jsx
index 9adf0e4..0eec3cc 100644
--- a/hubs/static/client/app/components/Icon.jsx
+++ b/hubs/static/client/app/components/Icon.jsx
@@ -1,17 +1,21 @@
 import React from 'react';
 
-const Icon = function (props) {
-  return (
-    <div className="media-left">
-      <a href={props.match.link ? props.match.link : '#'} target="_blank">
-        <img
-          alt="User avatar"
-          className="media-object square-32"
-          src={props.match.secondary_icon}
-        />
-      </a>
-    </div>
-  );
-};
+class Icon extends React.Component {
+  render() {
+    return (
+      <div>
+        <div className="media-left">
+          <a href={this.props.match.link ? this.props.match.link : '#'} target="_blank">
+            <img
+              alt="User avatar"
+              className="media-object square-32 img-circle"
+              src={this.props.match.secondary_icon}
+            />
+          </a>
+        </div>
+      </div>
+    );
+  }
+}
 
 export default Icon;
diff --git a/hubs/static/client/app/components/Panel.jsx b/hubs/static/client/app/components/Panel.jsx
index c443155..848a5b7 100644
--- a/hubs/static/client/app/components/Panel.jsx
+++ b/hubs/static/client/app/components/Panel.jsx
@@ -3,15 +3,17 @@ import React from 'react';
 import Icon from './Icon.jsx';
 import Markup from './Markup.jsx';
 
-const Panel = function (props) {
-  return (
-    <div className="card">
-      <div className="card-block" id={props.match.dom_id}>
-        <Icon match={props.match} />
-        <Markup options={props.options} match={props.match} />
+class Panel extends React.Component {
+  render() {
+    return (
+      <div className="card">
+        <div className="card-block" id={this.props.match.id}>
+          <Icon match={this.props.match} />
+          <Markup options={this.props.options} match={this.props.match} />
+        </div>
       </div>
-    </div>
-  );
-};
+    );
+  }
+}
 
 export default Panel;
